import numpy as np
import tensorflow as tf
from tensorflow.keras import Model
from tensorflow.keras.layers import Input, Dense
from tensorflow.keras.callbacks import Callback

samples_inp = np.array([[1,2,3],[1,1,1],[4,4,4],[9,9,9],[3,2,1],[0,0,1],[0,0,0]],np.float32)
samples_out = np.array([[123],[111],[444],[999],[321],[1],[0]],np.float32)

print(samples_inp)
print(samples_out)

inp = Input(shape=(3,))
out = Dense(1,activation='linear')(inp)
model = Model(inputs=inp, outputs=out)
model.summary()

model.compile(optimizer='adam', loss='mse', metrics=['mse'])

history = model.fit(samples_inp, samples_out, batch_size=7, epochs=130000)

model.save('linear-regressor.h5')

print(model.layers[1].get_weights())

# test
result = model.predict(np.array([[7,7,7]],np.float32))
print('test result',result[0])

# optional only
import matplotlib.pyplot as plt
# Loss Curves
plt.figure(figsize=[8,6])
plt.plot(history.history['loss'],'r',linewidth=3.0)
plt.legend(['Training loss'],fontsize=18)
plt.xlabel('Epochs ',fontsize=16)
plt.ylabel('Loss',fontsize=16)
plt.title('Loss Curves',fontsize=16)
#
plt.show()

#quit()
