import numpy as np
import tensorflow as tf
from tensorflow.keras.layers import Input
from tensorflow.keras.layers import Dense
from tensorflow.keras.models import Model

samples_inp = np.array([[1,2,3],[1,1,1],[4,4,4],[9,9,9],[3,2,1],[0,0,1],[0,0,0]],np.float32)
samples_out = np.array([[123],[111],[444],[999],[321],[1],[0]],np.float32)

inp = Input(shape=(3,))
mid = Dense(10,activation='linear')(inp)
out = Dense(1,activation='linear')(mid)
model = Model(inputs=inp, outputs=out)
model.summary()

model.compile(optimizer='adam', loss='mse', metrics=['mse', 'mae'])

model.fit(samples_inp, samples_out, batch_size=3, epochs=15000)

model.save('perceptron.h5')

print(model.layers[1].get_weights())
print(model.layers[2].get_weights())

# test
result = model.predict(np.array([[7,5,6]],np.float32))
print('test result',result[0])

#quit()
