import numpy as np
import tensorflow as tf
from tensorflow.keras.layers import Input
from tensorflow.keras.layers import Dense
from tensorflow.keras.models import Model
import matplotlib.pyplot as plt

def sigmoid(a):
    return 1/(1 + np.exp(-a))

# sigmod(-a) == 1-sigmoid(a)

N = 30

x = np.sort(np.random.rand(N)*7.0)-3

z = sigmoid(x)
plt.plot(x,z)    
plt.show()

z = sigmoid(100*x)
plt.plot(x,z)    
plt.show()

z = sigmoid(100*(x-1))
plt.plot(x,z)    
plt.show()
    
y = np.asarray((1<=x) & (x<=2),np.int32)
plt.plot(x,y)
plt.show()

z = 1 * sigmoid(100*x-100) + 1 * sigmoid(-100*x+200) - 1
#z = 1 * sigmoid(100*x-100) - 1 * sigmoid(100*x-200) + 0
plt.plot(x,z)    
plt.show()

samples_inp = x.reshape(-1,1)
samples_out = y.reshape(-1,1) 

inp = Input(shape=(1,))
hidden = Dense(2,activation='sigmoid')(inp)
out = Dense(1,activation='linear')(hidden)
model = Model(inputs=inp, outputs=out)
model.summary()

model.compile(optimizer='adam', loss='mse', metrics=['mse', 'mae'])

history = model.fit(samples_inp, samples_out, batch_size=N, epochs=15000)

plt.plot(history.history['loss'])
plt.show()

print(model.layers[1].get_weights())
print(model.layers[2].get_weights())

z = model.predict(samples_inp).reshape(-1)
plt.plot(x,z)    
plt.show()

z = 4.3077283 * sigmoid(5.614079*x-8.363278) - 4.321592 * sigmoid(5.455188*x-9.117299) - 0.00533463
plt.plot(x,z)    
plt.show()

#quit()
